#!/usr/bin/env python

import hal
import gtk
import gobject
import glib
#import linuxcnc
import serial
import threading
import sys
import time
#import memcache
from qTester2 import Motor, MakeMotor

#pause = hal.component("PauseOut")
#pause.newpin("p", hal.HAL_BIT, hal.HAL_IO)
#pause.ready()

numerr = 0;
mainclosed = 0
cmdarray = bytearray(2)
cmdarray[0] = 0
'''
try:
    s = linuxcnc.stat() # create a connection to the status channel
    s.poll() # get current values
except linuxcnc.error, detail:
    print "LINUXCNC error", detail
    gtk.main_quit()
    sys.exit(1)
#for x in dir(s):
#    if not x.startswith('_'):
#        print x, getattr(s,x)
'''
        
class myThread2 (threading.Thread):
	def __init__(self, threadID, name):
		threading.Thread.__init__(self)
		self.threadID = threadID
		self.name = name
	def run(self):
		print "Starting " + self.name
		motorInit(self.name)
		print "Exiting " + self.name

def motorInit(threadName):
	currentMotor = Motor(5,2,9)
	try:
		print "Success %d" % MakeMotor(currentMotor)
	except (NameError,ValueError,RuntimeError):
		print "MakeMotor failed."
		#Raise error
		#eout.Finger = 1

class HandlerClass:

	def __init__(self,halcomp,builder,useropts):
		filename = "/home/stan/Documents/gladetests/test3.ui"
		builder = gtk.Builder()
		builder.add_from_file(filename)
		builder.connect_signals(self)
		
	def on_hal_table1_destroy(self, widget, data=None):
		print "quit with close"
		mainclosed = 1
		#self.halcomp.exit()
		gtk.main_quit()
		return False
		
	def on_unix_signal(self,signum,stack_frame):
		print "on_unix_signal(): signal %d received, saving state" % (signum)
		self.ini.save_state(self)
		gtk.main_quit()
		self.halcomp.exit()

#	def on_hal_led1_hal_pin_changed(self,hal_led1,data=None):
#		n = 0
#		#while True:
#		#ser = serial.Serial('/dev/ttyUSB0')
#		#ser.open()
#	 	#ser.write('1')
#	 	#print ser.read(2)
#	 	#ser.close()
#	     
#	def on_hal_button1_pressed(self,hal_button1,data=None):
#		#n = 0
#		#print "%f" % n
#		#nhits += 1 
#		#hal_label1.set_label("hits: %d" % nhits)
#		hal_button1.set_label("aha!")

	def on_start_led_hal_pin_changed(self,start_led,data=None):
		pass

	def on_pause_button_clicked(self,start_button,data=None):
		pass
		#pause.p = 1

	def on_start_button_clicked(self,start_button,data=None):
		print "Motor Start Button"
		#pause.p = 0
    
def get_handlers(halcomp,builder,useropts):
	for cmd in useropts:
		exec cmd in globals()
	return [HandlerClass(halcomp,builder,useropts)]

thread2 = myThread2(2,"Motor-Thread-1")
#thread1.daemon = True;
thread2.start()

if __name__ == "__main__":
  main = main()
  gtk.main()

print "Exiting Main Thread"
