import sys
import linuxcnc
import hal

s = linuxcnc.stat()
c = linuxcnc.command()
e = linuxcnc.error_channel()

error = e.poll()

if error:
	kind, text = error
	if kind in (linuxcnc.NML_ERROR, linuxcnc.OPERATOR_ERROR):
		typus = "error"
	else:
		typus = "info"
		print typus, text

def ok_for_mdi():
	s.poll()
	return not s.estop and s.enabled and s.homed and (s.interp_state == linuxcnc.INTERP_IDLE)	

#motorcount

STATE_END_OF_CCW = 16;
STATE_END_OF_TIE1 = 26;
STATE_END_OF_CW = 41;
STATE_END_OF_TIE2 = 59;
STATE_TIE1_1 = 5;
STATE_TIE1_2 = 6;
STATE_TIE2_1 = 30;
STATE_TIE2_2 = 39;
STATE_FINISH = 64;

"""
while stuff happens

	wind one set
	
		set 1,2,3,4,5,6
		
			if first winding -> attach
			
			windCCW
			
			tie1
			
			windCW
			
			tie2
			
			windCCW
			
			terminate
		
	if set completed -> increment motorcount

windingSets = bytearray(6)
windingPoles = bytearray(3)
windingTurns = bytearray(10)

windingSets = range(0,6)
windingPoles = range(0,3)
windingTurns = range(0,10)

windingSet = 0
windingPole = 0
windingTurn = 0
"""

def frontToward():
	print "frontToward"
def frontAway():
	print "frontAway"
def backToward():
	print "backToward"
def backAway():
	print "backAway"
def forward1Pole():
	print "forward1Pole"
def back1Pole():
	print "back1Pole"
def forwardBump():
	print "forwardBump"
def	backBump():
	print "backBump"
def frontAway_cyl1st():
	print "frontAway_cyl1st"
def frontToward_tie2():
	print "frontToward_tie2"

class fingers():
	@classmethod
	def CCW1(cls,motorobj):
		if (motorobj.windingTurn >= 2):
			frontAway
			backAway
		elif (motorobj.laststate == STATE_END_OF_TIE2):
			frontAway
			backAway
		if (motorobj.windingTurn >= 6):
			backBump
			backBump	
			
		#If not first windCCW iteration
		#	Move both fingers away
		#If coming from Tie2
		#	Move both fingers away
		#If loops>=6, bump stator back (neg) twice

	@classmethod
	def CCW2(cls,motorobj):
		if (motorobj.windingTurn >= 5):
			backBump
		if (motorobj.laststate == STATE_ATTACH_WIRE):  # Note that this won't work because the state index will not go back far enough.
			loops = 0
			backToward
		else:
			backToward
			
		#If loops>=5, bump stator backward once
		#If coming from attach_wire
		#	Back finger forward at height 0
		#else
		#	Back finger forward	
	
	@classmethod
	def CCW3(cls,motorobj):
		if (motorobj.windingTurn >= 5):
			forwardBump
			
		#If loops>=5, bump stator forward once
		
	@classmethod
	def CCW4(cls,motorobj):
		if (motorobj.windingTurn >= 5) and (motorobj.windingTurn < 9):
			forwardBump
			forwardBump
		frontToward
		backAway
	
		#If loops>=5 and <9
		#	Bump stator forward twice
		#Front finger toward
		#Back finger away
		
	@classmethod
	def tie1_1(cls,motorobj):
		loops = 0
		frontAway_cyl1st
		
		#Retract cylinder, move front finger away, height 0
		
	@classmethod
	def tie1_2(cls,motorobj):
		loops = 9
		frontToward
		loops = 0
		backAway
	
		#Front finger to the stator at loops=9
		#Back finger away at loops=0
		
	@classmethod
	def tie1_3(cls,motorobj):
		loops = 1
		frontAway_cyl1st
		back1Pole
		backToward
		frontAway
		
		#loops = 1 
		#Front finger away, cylinder first
		#Stator backward one pole
		
		#Back finger toward
		#Front finger away
	
	@classmethod
	def CW1(cls,motorobj):
		if (motorobj.windingTurn >= 5):
			backBump
		frontToward
		backAway
	
		#if loops>=5
		#	bump stator back once
		#Front finger toward
		#Back finger away
		
	@classmethod
	def CW2(cls,motorobj):
		forwardBump
		forwardBump
		forwardBump
		
		#bump stator forward three times
		
	@classmethod
	def CW3(cls,motorobj):
		backToward
		frontAway
	
		#back finger toward
		#front finger away
	
	@classmethod
	def CW4(cls,motorobj):
		if (motorobj.windingTurn >= 5):
			backBump
			backBump
	
		#if loops>=5
		#	bump stator back twice
			
	@classmethod
	def tie2_1(cls,motorobj):
		loops = 2
		frontToward_tie2
		backAway
	
		#loops = 2
		#front finger to stator CW to CCW
		#back finger away
	
	@classmethod
	def tie2_2(cls,motorobj):
		frontAway
		back1Pole
	
		#right finger away
		#rotate one pole back
		
	@classmethod
	def tie2_3(cls,motorobj):
		backToward
		
		#back finger toward
		
	@classmethod
	def tie2_4(cls,motorobj):
		frontToward
		backAway
	
		#front finger toward
		#back finger away

class windCCW():
	@classmethod
	def p1(cls,motorobj):
		print "WindCCW p1"
	@classmethod
	def p2(cls,motorobj):
		print "WindCCW p2"
	@classmethod
	def p3(cls,motorobj):
		print "WindCCW p2"
	@classmethod
	def p4(cls,motorobj):
		print "WindCCW p2"
	@classmethod
	def p5(cls,motorobj):
		print "WindCCW p2"
	@classmethod
	def p6(cls,motorobj):
		print "WindCCW p2"
	@classmethod
	def p7(cls,motorobj):
		print "WindCCW p2"
	@classmethod
	def p8(cls,motorobj):
		print "WindCCW p2"
	
class tie1():
	@classmethod	
	def p1(cls,motorobj):
		print "tie1 p1"
	@classmethod
	def p2(cls,motorobj):
		print "tie1 p2"
	@classmethod
	def p3(cls,motorobj):
		print "tie1 p3"
	@classmethod
	def p4(cls,motorobj):
		print "tie1 p4"
		
class windCW():8
	@classmethod
	def p1(cls,motorobj):
		print "windCW p1"
	@classmethod
	def p2(cls,motorobj):
		print "windCW p2"
	@classmethod
	def p3(cls,motorobj):
		print "windCW p3"
	@classmethod
	def p4(cls,motorobj):
		print "windCW p4"
	@classmethod
	def p5(cls,motorobj):
		print "windCW p5"
	@classmethod
	def p6(cls,motorobj):
		print "windCW p6"
	@classmethod
	def p7(cls,motorobj):
		print "windCW p7"
	@classmethod
	def p8(cls,motorobj):
		print "windCW p8"
	
class tie2():11
	@classmethod
	def p1(cls,motorobj):
		print "tie2 p1"
	@classmethod
	def p2(cls,motorobj):
		print "tie2 p2"
	@classmethod
	def p3(cls,motorobj):
		print "tie2 p3"
	@classmethod
	def p4(cls,motorobj):
		print "tie2 p4"
	@classmethod
	def p5(cls,motorobj):
		print "tie2 p5"
	@classmethod
	def p6(cls,motorobj):
		print "tie2 p6"
	@classmethod
	def p7(cls,motorobj):
		print "tie2 p7"
	@classmethod
	def p8(cls,motorobj):
		print "tie2 p8"
	@classmethod
	def p9(cls,motorobj):
		print "tie2 p9"
	@classmethod
	def p10(cls,motorobj):
		print "tie2 p10"
	@classmethod
	def p11(cls,motorobj):
		print "tie2 p11"
		
def finish():
	print "Finished"

windingProcOptions = {	0: startup,
						1: attach_wire,
						
						####################
						
						5: windCCW.p1,
						6: windCCW.p2,
						7: fingers.CCW1,
						8: windCCW.p3,
						9: fingers.CCW2,
						10: windCCW.p4,
						11: windCCW.p5,
						12: windCCW.p6,
						13: fingers.CCW3,
						14: windCCW.p7,
						15: fingers.CCW4,
						16: windCCW.p8,
					
						####################
					
						20: tie1.p1,
						21: fingers.tie1_1,
						22: tie1.p2,
						23: fingers.tie1_2,
						24: tie1.p3,
						25: fingers.tie1_3,
						26: tie1.p4,
						
						####################
						
						30: windCW.p1,
						31: windCW.p2,
						32: fingers.CW1,
						33: windCW.p3,
						34: windCW.p4,
						35: windCW.p5,
						36: fingers.CW2,
						37: windCW.p6,
						38: fingers.CW3,
						39: windCW.p7,
						40: windCW.p8,						
						41: fingers.CW4,
							
						####################
						
						45: tie2.p1,
						46: tie2.p2,
						47: fingers.tie2_1
						48: tie2.p3,
						49: tie2.p4,
						50: tie2.p5,
						51: fingers.tie2_2
						52: tie2.p6,
						53: fingers.tie2_3
						54: tie2.p7,
						55: tie2.p8,
						56: tie2.p9,
						57: tie2.p10,
						58: fingers.tie2_4
						59: tie2.p11,
						
						####################
						
						64: finish,						
}

"""
windingLocOptions = {	'TFR': 1,
						'TFL': 2,
						'TBR': 3,
						'TBL': 4,
						'BFR': 5,
						'BFL': 6,
						'BBR': 7,
						'BBL': 8,
}	

windingProcOptions = {	0: windCCW.p1,
						1: windCCW.p2,
						2: tie1.p1,
						3: tie1.p2,
						4: windCW.p1,
						5: tie2.p1,
						6: finish,			
}
"""

def checkLoc(currentMotor):
	return currentMotor.state

def MakeMotor(currentMotor):
	if currentMotor.windingTurn >= 5:
		xoff = 0
	else:
		xoff = 1
	
	while True:		
		if (checkLoc(currentMotor) == currentMotor.state):
			if ok_for_mdi():
				c.mode(linuxcnc.MODE_MDI)
				c.wait_complete()
			currentMotor.wind()
			currentMotor.next()
		elif (checkLoc(currentMotor) == currentMotor.laststate):
			currentMotor.wind()
			print "log - Repeated Movement Signal"
		else:
			print "Operator Reset Request"

		if (currentMotor.state = STATE_END_OF_CCW) and (currentMotor.windingTurn < currentMotor.turns) and (currentMotor.windingPole < currentMotor.poles):
			currentMotor.windingTurn += 1
			currentMotor.state = STATE_CCW_1
			currentMotor.nextstate = STATE_CCW_2
		elif (currentMotor.state = STATE_END_OF_CCW) and (currentMotor.windingTurn >= currentMotor.turns) and (currentMotor.windingPole < currentMotor.poles):
			currentMotor.windingTurn = 0
			currentMotor.windingPole += 1
			currentMotor.state = STATE_TIE1_1
			currentMotor.nextstate = STATE_TIE1_2
		elif (currentMotor.state = STATE_END_OF_CCW) and (currentMotor.windingTurn >= currentMotor.turns) and (currentMotor.windingPole >= currentMotor.poles):
			currentMotor.windingTurn = 0
			currentMotor.windingPole = 0
			currentMotor.state = STATE_FINISH
			currentMotor.nextstate = STATE_FINISH
			
		if 	(currentMotor.state = STATE_END_OF_TIE1):
			currentMotor.windingTurn = 1
			currentMotor.state = STATE_CW_1
			currentMotor.nextstate = STATE_CW_2
		
		if (currentMotor.state = STATE_END_OF_CW) and (currentMotor.windingTurn < currentMotor.turns) and (currentMotor.windingPole < currentMotor.poles):
			currentMotor.windingTurn += 1
			currentMotor.state = STATE_CCW_1
			currentMotor.nextstate = STATE_CCW_2
		elif (currentMotor.state = STATE_END_OF_CW) and (currentMotor.windingTurn >= currentMotor.turns) and (currentMotor.windingPole < currentMotor.poles):
			currentMotor.windingTurn = 0
			currentMotor.windingPole += 1
			currentMotor.state = STATE_TIE2_1
			currentMotor.nextstate = STATE_TIE2_2
		elif (currentMotor.state = STATE_END_OF_CW) and (currentMotor.windingTurn >= currentMotor.turns) and (currentMotor.windingPole >= currentMotor.poles):
			currentMotor.windingTurn = 0
			currentMotor.windingPole = 0
			currentMotor.state = STATE_FINISH
			currentMotor.nextstate = STATE_FINISH
			
		if 	(currentMotor.state = STATE_END_OF_TIE2):
			currentMotor.windingTurn = 1
			currentMotor.state = STATE_CCW_1
			currentMotor.nextstate = STATE_CCW_2
		
		#if currentMotor.state == 6:
			#return 1

class Motor():
	def __init__(self, windingSets, polesPerSet, turnsPerPole):
		self.sets = windingSets
		self.poles = polesPerSet
		self.turns = turnsPerPole
		self.windingSet = 0
		self.windingPole = 0
		self.windingTurn = 0
		self.state = 0
		self.laststate = 0
		self.nextstate = 1
		
	def wind(self):
		windingProcOptions[self.state](self)
		
	def next(self):
		self.laststate = self.state
		self.state = self.nextstate
		self.nextstate = self.state + 1

currentMotor = Motor(6,3,10)
try:
	print "Success %d" % MakeMotor(currentMotor)
except (NameError,ValueError,RuntimeError):
	print "MakeMotor failed."
	#Raise error



#func startWinding
#		checkLLL
#		goToLLL

	
#func ROBOTCRASH

#func FINGERCRASH

#func LINUXCNCCRASH

#func PYTHONCRASH

#func GLADECRASH

#func MEMCACHECRASH

#func logLLL

#func goToLLL

#func goToSafe

#func checkLoc
